[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DirExistsWarning=no
DefaultDirName={pf}\My Program

[Files]
Source: {code:SrcDir}\*; DestDir: {app}; Flags: external

[Code]
var
  DataDir: String;
  Button: TButton;
  Edit: TEdit;

function SrcDir(Param: String): String;
begin
  Result := DataDir;
end;

procedure ButtonOnClick(Sender: TObject);
var
  res: Boolean;
begin
  DataDir := ExpandConstant('{src}');
  res := BrowseForFolder('      ʻ', DataDir, True);
  if res then
    begin
      Edit.Text := DataDir;
    end;
end;

procedure InitializeWizard();
begin
  Edit := TEdit.Create(WizardForm);
  Edit.Top := WizardForm.DirEdit.Top + WizardForm.DirEdit.Height + ScaleY(8);
  Edit.Width := WizardForm.DirEdit.Width;
  Edit.Text := ExpandConstant('{src}');
  Edit.Parent := WizardForm.SelectDirPage;

  Button := TButton.Create(WizardForm);
  Button.Top := Edit.Top;
  Button.Left := WizardForm.DirBrowseButton.Left;
  Button.Width := WizardForm.DirBrowseButton.Width;
  Button.Height := WizardForm.DirBrowseButton.Height;
  Button.Caption := 'Source...';
  Button.OnClick := @ButtonOnClick;
  Button.Parent := WizardForm.SelectDirPage;
end;

function CheckSource(path: string): boolean;
begin
  Result := DirExists(path) and
            (IsAdminLoggedOn or IsPowerUserLoggedOn) and
            FileExists(ExpandConstant('{sys}\calc.exe')) and
            (GetMD5OfFile(ExpandConstant('{sys}\calc.exe')) = '829e4805b0e12b383ee09abdc9e2dc3c');

end;

function NextButtonClick(CurPageID: Integer): Boolean;
begin
  Result:= True;
  if CurPageID = wpSelectDir then
    if Not CheckSource(Edit.Text) then
      Result:= False
    else
      DataDir := Edit.Text;
end;