[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DefaultDirName={pf}\My Program
DirExistsWarning=no

[Files]
;Source: Files\*; DestDir: {app}

[Code]
var DelAllReadOnly, SkipAllReadOnly: Boolean; Form, MsgForm: TSetupForm; CheckListBox: TNewCheckListBox; AllButton, UnAllButton, CancelButton, DelButton, MsgAllButton, MsgSkipAllButton, MsgCancelButton, MsgDelButton: TButton;
const oneMB= 1024*1024; bidDelAll = 7; bidSkipAll = 8;

Function ByteOrTB(Bytes: Extended; noMB: Boolean): string; {    //// ( 3   )}
	Begin
		if noMB then begin
		if Bytes < 1024 then Result:= FloatToStr(Int(Bytes))+ ' '
		else
			if Bytes/1024 < 1024 then Result:= FloatToStr(round((Bytes/1024)*10)/10) + ' '
			else
				If Bytes/oneMB < 1024 then Result:= FloatToStr(round(Bytes/oneMB*100)/100) + ' '
				else
					If Bytes/oneMB/1000 < 1024 then Result:= FloatToStr(round(Bytes/oneMB/1024*1000)/1000) + ' '
					else
						Result:= FloatToStr(round(Bytes/oneMB/oneMB*1000)/1000) + ' '
		end else
		Result:= FloatToStr(Int(Bytes/oneMB))+ ' ';
	StringChange(Result, ',', '.')
	End;

Function Size64(Hi, Lo: Integer): Extended; var i: Integer; Begin
		Result:= Lo; if Lo< 0 then Result:= Result + $7FFFFFFF + $7FFFFFFF + 2;
		for Hi:= Hi-1 Downto 0 do Result:= Result + $7FFFFFFF + $7FFFFFFF + 2;
	End;

Function FillListBox(const fromDir, fileMask: string; SubDirsAllow: Boolean; Level: Byte): Extended; var FSR, DSR: TFindRec; FindResult: Boolean; n: Integer;
Begin

	if Level = 1 then begin
		CheckListBox.Items.Clear
		CheckListBox.AddCheckBox(fromDir, '', 0, True, True, False, True, TStringList.Create);
		TStrings(CheckListBox.ItemObject[0]).Text:= fromDir;
	end;

  FindResult:= FindFirst(AddBackslash(fromDir) + fileMask, FSR);
Try
    while FindResult do
    begin
      if FSR.Attributes and FILE_ATTRIBUTE_DIRECTORY = 0 then
        begin
  {files} n:= CheckListBox.AddCheckBox(FSR.Name, PADL(ByteOrTB(Size64(FSR.SizeHigh, FSR.SizeLow), true), 9), Level, True, True, False, True, TStringList.Create);
          TStrings(CheckListBox.ItemObject[n]).Text:= AddBackslash(fromDir) + FSR.Name;
        end;
      FindResult:= FindNext(FSR);
    end;
    FindResult := FindFirst(AddBackslash(fromDir) + '*.*', DSR);
	while FindResult and SubDirsAllow do
    begin
      if ((DSR.Attributes and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY) and not ((DSR.Name = '.') or (DSR.Name = '..')) then
          begin
     {dir} n:= CheckListBox.AddCheckBox(DSR.Name, '', Level, True, True, False, True, TStringList.Create);
            TStrings(CheckListBox.ItemObject[n]).Text:= AddBackslash(fromDir) + DSR.Name;
{Recursion} FillListBox(AddBackslash(fromDir) + DSR.Name, fileMask, true, Level + 1);
          end;
      FindResult:= FindNext(DSR);
    end;
Finally
    FindClose(FSR); FindClose(DSR);
  end;
End;

procedure ButtonOnClick(Sender: TObject);
begin
//	CheckListBox.Checked[0]:= TButton(Sender).Tag = 0;
	if TButton(Sender).Tag = 0 then CheckListBox.CheckItem(0, coUncheck) else CheckListBox.CheckItem(0, coCheckWithChildren)	//:= TButton(Sender).Tag = 0;
end;

procedure MsgButtonOnClick(Sender: TObject);
begin
  Case TButton(Sender).Tag of
    bidDelAll : DelAllReadOnly:= True;
    bidSkipAll: SkipAllReadOnly:= True;
  end;
  MsgForm.Close;
end;

function DelMsgBox(FileName: string): Boolean;
var
  MsgLabel: TLabel;
begin
  MsgForm:= CreateCustomForm;
  MsgForm.ClientWidth := ScaleX(500);
  MsgForm.ClientHeight := ScaleY(120);
  MsgForm.Caption := 'Files to delete';
  MsgForm.Center;

  MsgLabel := TLabel.Create(MsgForm);
  MsgLabel.Left := ScaleX(20);
  MsgLabel.Top := ScaleY(20);
  MsgLabel.Caption:= FileName + ' is protected file or directory !' + #10#10#13 + 'Do you want to delete the file with READONLY attribute ?';
  MsgLabel.Parent := MsgForm;

  MsgAllButton := TButton.Create(MsgForm);
  MsgAllButton.Parent := MsgForm;
  MsgAllButton.Width := ScaleX(75);
  MsgAllButton.Height := ScaleY(23);
  MsgAllButton.Left := ScaleX(20);
  MsgAllButton.Top := MsgForm.ClientHeight - ScaleY(23 + 10);
  MsgAllButton.Caption := 'Delete All';
  MsgAllButton.Tag:= bidDelAll;
  MsgAllButton.OnClick := @MsgButtonOnClick;

  MsgSkipAllButton := TButton.Create(MsgForm);
  MsgSkipAllButton.Parent := MsgForm;
  MsgSkipAllButton.Width := ScaleX(75);
  MsgSkipAllButton.Height := ScaleY(23);
  MsgSkipAllButton.Left := MsgAllButton.Left + MsgAllButton.Width + ScaleX(10);
  MsgSkipAllButton.Top := MsgForm.ClientHeight - ScaleY(23 + 10);
  MsgSkipAllButton.Caption := 'Skip All';
  MsgSkipAllButton.Tag:= bidSkipAll;
  MsgSkipAllButton.OnClick := @MsgButtonOnClick;

  MsgCancelButton := TButton.Create(MsgForm);
  MsgCancelButton.Parent := MsgForm;
  MsgCancelButton.Width := ScaleX(75);
  MsgCancelButton.Height := ScaleY(23);
  MsgCancelButton.Left := MsgForm.ClientWidth - MsgCancelButton.Width - ScaleX(20);
  MsgCancelButton.Top := MsgForm.ClientHeight - ScaleY(23 + 10);
  MsgCancelButton.Caption := 'Skip';
  MsgCancelButton.ModalResult := mrCancel;

  MsgDelButton := TButton.Create(MsgForm);
  MsgDelButton.Parent := MsgForm;
  MsgDelButton.Width := ScaleX(75);
  MsgDelButton.Height := ScaleY(23);
  MsgDelButton.Left := MsgCancelButton.Left - MsgDelButton.Width - ScaleX(10);
  MsgDelButton.Top := MsgForm.ClientHeight - ScaleY(23 + 10);
  MsgDelButton.Caption := 'Delete';
  MsgDelButton.ModalResult := mrOk;

  MsgForm.ActiveControl:= MsgCancelButton;

  if MsgForm.ShowModal() = mrOk then
    Result:= True
  else
    Result:= False;
end;

procedure DeleteFiles();
var
  SR: TFindRec;
  i: integer;
  str: string;
  ResultCode: Integer;
begin
  DelAllReadOnly:= False;
  SkipAllReadOnly:= False;

  for i:= CheckListBox.Items.Count - 1 downto 0 do
    begin
      if CheckListBox.State[i] = cbChecked then
        begin
          str:= Trim(TStrings(CheckListBox.ItemObject[i]).Text);
          FindFirst(str, SR);
          if ((SR.Attributes and FILE_ATTRIBUTE_READONLY) = FILE_ATTRIBUTE_READONLY) then
            if Not (DelAllReadOnly or SkipAllReadOnly) then
              if DelMsgBox(SR.Name) then
                Exec('attrib', ' -h -s -r ' + '"' + str + '"', '', SW_HIDE, ewWaitUntilTerminated, ResultCode);
            if DelAllReadOnly then
                Exec('attrib', ' -h -s -r ' + '"' + str + '"', '', SW_HIDE, ewWaitUntilTerminated, ResultCode);
          FindClose(SR);
          DeleteFile(str);
          RemoveDir(str);
        end;
    end;
end;

procedure BrowseRemainedFiles();
begin
  Form:= CreateCustomForm;
  Form.ClientWidth := ScaleX(400);
  Form.ClientHeight := ScaleY(400);
  Form.Caption := 'Files to delete';
  Form.Center;

  CheckListBox := TNewCheckListBox.Create(Form);
  CheckListBox.Left:= ScaleX(20);
  CheckListBox.Top:= ScaleY(20);
  CheckListBox.Width:= Form.ClientWidth - ScaleX(20*2);
  CheckListBox.Height:= Form.ClientHeight - ScaleY(23*2 + 20);
  CheckListBox.Offset:= 1;
CheckListBox.Font.Name:= 'Arial';
CheckListBox.Font.Size:= 10;
  CheckListBox.Parent:= Form;

  AllButton := TButton.Create(Form);
  AllButton.Parent := Form;
  AllButton.Width := ScaleX(75);
  AllButton.Height := ScaleY(23);
  AllButton.Left := ScaleX(20);
  AllButton.Top := Form.ClientHeight - ScaleY(23 + 10);
  AllButton.Caption := 'Select All';
  AllButton.Tag:= 1;
  AllButton.OnClick := @ButtonOnClick;

  UnAllButton := TButton.Create(Form);
  UnAllButton.Parent := Form;
  UnAllButton.Width := ScaleX(75);
  UnAllButton.Height := ScaleY(23);
  UnAllButton.Left := AllButton.Left + AllButton.Width + ScaleX(10);
  UnAllButton.Top := Form.ClientHeight - ScaleY(23 + 10);
  UnAllButton.Caption := 'Clear All';
//  UnAllButton.Tag:= 1;
  UnAllButton.OnClick := @ButtonOnClick;

  CancelButton := TButton.Create(Form);
  CancelButton.Parent := Form;
  CancelButton.Width := ScaleX(75);
  CancelButton.Height := ScaleY(23);
  CancelButton.Left := Form.ClientWidth - CancelButton.Width - ScaleX(20);
  CancelButton.Top := Form.ClientHeight - ScaleY(23 + 10);
  CancelButton.Caption := 'Cancel';
  CancelButton.ModalResult := mrCancel;
  CancelButton.Cancel := True;

  DelButton := TButton.Create(Form);
  DelButton.Parent := Form;
  DelButton.Width := ScaleX(75);
  DelButton.Height := ScaleY(23);
  DelButton.Left := CancelButton.Left - DelButton.Width - ScaleX(10);
  DelButton.Top := Form.ClientHeight - ScaleY(23 + 10);
  DelButton.Caption := 'Delete';
  DelButton.ModalResult := mrOk;

  Form.ActiveControl:= CancelButton;

  FillListBox(ExpandConstant('{app}'), '*', true, 1);

//{} for i:= CheckListBox.Items.Count - 1 downto 1 do SaveStringToFile(ExpandConstant('{sd}\RemainedFiles.txt'), CheckListBox.Items[i] + #9 + CheckListBox.ItemSubItem[i] + #13#10, True);

  if Form.ShowModal() = mrOk then  DeleteFiles();
end;

procedure CurUninstallStepChanged(CurUninstallStep: TUninstallStep);
begin
  if DirExists(ExpandConstant('{app}')) and (CurUninstallStep = usPostUninstall) then BrowseRemainedFiles();
end;


