[Setup]
AppName=Calc DirSize
AppVerName=Calc DirSize
CreateAppDir=false

[Code]
var
	Browse, SizeButton: TButton; LSize: TLabel; Folder: String; StopWork: Boolean;
const
	oneMB= 1024*1024; VK_SHIFT = $10;

function GetKeyState(nVirtKey: Integer): ShortInt; external 'GetKeyState@user32 stdcall delayload';

Function ByteOrGB(Bytes: Extended; noMB: Boolean): String; {     /// ( 3   )}
Begin
	if not noMB then Result:= FloatToStr(Int(Bytes)) +' Mb' else
		if Bytes < 1024 then if Bytes = 0 then Result:= '0' else Result:= FloatToStr(Int(Bytes)) +' Bt' else
			if Bytes/1024 < 1024 then Result:= FloatToStr(round((Bytes/1024)*10)/10) +' Kb' else
				If Bytes/oneMB < 1024 then Result:= FloatToStr(round(Bytes/oneMB*100)/100) +' Mb' else
					Result:= FloatToStr(round(Bytes/oneMB/1024*1000)/1000) +' Gb'
	StringChange(Result, ',', '.')
End;

Function Size64(Hi, Lo: Integer): Extended;
Begin
	Result:= Lo; if Lo< 0 then Result:= Result + $7FFFFFFF + $7FFFFFFF + 2; for Hi:= Hi-1 Downto 0 do Result:= Result + $7FFFFFFF + $7FFFFFFF + 2;
End;

function CalcDirSize(const fromDir, fileMask: string; SubDirsAllow: Boolean): Extended;
var
	FSR, DSR: TFindRec; FindResult: Boolean; APath: string;
Begin
	APath:= AddBackslash(fromDir);
	FindResult:= FindFirst(APath + fileMask, FSR);
  Try
	while FindResult do
	begin
	  if FSR.Attributes and FILE_ATTRIBUTE_DIRECTORY = 0 then Result:= Result + Size64(FSR.SizeHigh, FSR.SizeLow)
	  FindResult:= FindNext(FSR);
	end;
	  FindResult := FindFirst(APath + '*.*', DSR);
	while FindResult and SubDirsAllow do
	begin
	  if ((DSR.Attributes and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY) and not ((DSR.Name = '.') or (DSR.Name = '..')) then
	{Recursion} Result:= Result + CalcDirSize(APath + DSR.Name, fileMask, SubDirsAllow);
//	    ,   -  
	  FindResult:= FindNext(DSR);
	end;
  Finally
	FindClose(FSR); FindClose(DSR);
  end;
End;

Procedure SizeButtonOnClick(Sender: TObject); var res: Extended;
Begin
	LSize.Caption:= 'Please wait...' #13#10 'Calculating folders'; WizardForm.Repaint
	res:= CalcDirSize(Folder, '*', True);	//   (   SHFileOperation)  ,      
	LSize.Caption:= 'DirSize = ' + ByteOrGB(res, true) + #13#10 + Folder
End;

Procedure BrowseOnClick(Sender: TObject);
Begin
	if BrowseForFolder('Calc Folder', Folder, false) then SizeButtonOnClick(SizeButton);
End;

Procedure InitializeWizard;
begin
  Browse:= TButton.Create(WizardForm);
  Browse.SetBounds(WizardForm.ClientWidth - WizardForm.CancelButton.Left - WizardForm.CancelButton.Width, WizardForm.CancelButton.Top, 48, WizardForm.CancelButton.Height)
  Browse.Caption := 'Change';
  Browse.OnClick := @BrowseOnClick;
  Browse.Parent := WizardForm;

  SizeButton:= TButton.Create(WizardForm);
  SizeButton.SetBounds(Browse.Left + Browse.Width, WizardForm.CancelButton.Top, WizardForm.CancelButton.Width/2, WizardForm.CancelButton.Height)
  SizeButton.Caption := 'Calc';
  SizeButton.OnClick := @SizeButtonOnClick;
  SizeButton.Parent := WizardForm;

  Folder:= ExpandConstant('{win}')	//     

  LSize:= TLabel.Create(WizardForm);
  LSize.SetBounds(SizeButton.Left + SizeButton.Width + 8, SizeButton.Top, 12, 12)
  LSize.Caption:= 'Click Calc button' #13#10 'Current dir: ' + Folder;
  LSize.Parent:= WizardForm;
end;
