[Setup]
AppName=My Prog
AppVerName=My Prog v1.0
DefaultDirName={sd}\My Prog

[Files]
Source: "C:\BASSMOD.dll"; DestDir: "{tmp}"; Flags: dontcopy
Source: "C:\music.s3m"; DestDir: "{tmp}"; Flags: dontcopy

[Code]
const
  BASS_MUSIC_RAMP               = 1;      // (  Fast Tracker .xm)
  BASS_MUSIC_RAMPS             = 2;      // (  Fast Tracker .xm)
  BASS_MUSIC_LOOP                = 4;      // 
  BASS_MUSIC_FT2MOD           = 16;     //  .MOD  FastTracker 2
  BASS_MUSIC_PT1MOD           = 32;     //  .MOD  ProTracker 1
  BASS_MUSIC_SURROUND     = 512;    //  surround
  BASS_MUSIC_SURROUND2   = 1024;   //  surround ( 2)

function BASSMOD_Init(device: Integer; freq, flags: DWORD): Boolean;
external 'BASSMOD_Init@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_MusicFree();
external 'BASSMOD_MusicFree@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicLoad(mem: BOOL; f: PChar; offset: DWORD; length: DWORD; flags: DWORD): Boolean;
external 'BASSMOD_MusicLoad@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPlay(): Boolean;
external 'BASSMOD_MusicPlay@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicStop(): Boolean;
external 'BASSMOD_MusicStop@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPause(): Boolean;
external 'BASSMOD_MusicPause@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_Free();
external 'BASSMOD_Free@files:BASSMOD.dll stdcall delayload';

var
  cb:TCheckBox;

procedure PlayOnClick;
var
  Name1: string;
begin
  BASSMOD_MusicFree;
begin
if not BASSMOD_MusicPlay then
 begin
   Name1:=ExpandConstant('{tmp}\music.s3m');
 if BASSMOD_MusicLoad(FALSE, PChar(Name1), 0, 0, BASS_MUSIC_LOOP or BASS_MUSIC_SURROUND or 32 or 1) then
  BASSMOD_MusicPlay;
end;
end;
end;

procedure cdClick(Sender: TObject);
begin
If cb.CHECKED then
PlayOnClick
else
 BASSMOD_MusicStop;
end;

procedure InitializeWizard();
var
CancelButton: TButton;
begin
  ExtractTemporaryFile(ExpandConstant('BASSMOD.dll'));
  ExtractTemporaryFile(ExpandConstant('music.s3m'));
   if not BASSMOD_Init(-1,44100,0)
then
begin
// dll   
  MsgBox('BASSMOD   ,   .', mbError, MB_OK)
  BASSMOD_Free;
end;
  cb:=TCheckBox.Create(WizardForm);
  cb.Parent:=WizardForm;
  cb.Width:=ScaleX(220);
  cb.Left:=ScaleY(10);
  cb.Top:=ScaleY(330);
  cb.CAPTION:=' ';
  cb.ONCLICK:=@cdClick;
  cb.checked:=true;
end;

procedure DeInitializeSetup();
begin
BASSMOD_MusicStop; //   ,    ,   :
BASSMOD_Free(); //     
end;



