[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DirExistsWarning=no
DefaultDirName={pf}\My Program

[Code]
function FindWindowEx(hWndM, hWndC: LongWord; lpszClass, lpszWindow: PChar): LongWord; external 'FindWindowExA@user32.dll stdcall';

procedure Zip(aSrc, aDst: string);
var
  shell, srcFolder, dstFolder: Variant;
  zipstr: string;
  i: integer;
begin
  if not FileExists(aDst) then
    begin
      zipstr:= Chr($50)+Chr($4B)+Chr($05)+Chr($06);
      for i:= 0 to 17 do
        zipstr:= zipstr + #0;
      ForceDirectories(ExtractFileDir(aDst));
      SaveStringToFile(aDst, zipstr, False);
    end;
  shell:= CreateOleObject( 'Shell.Application' );
  dstfolder:= shell.NameSpace( aDst );
  if DirExists(aSrc) then
    begin
      srcFolder:= shell.NameSpace( aSrc );
      dstfolder.CopyHere( srcFolder.Items, 0);
    end else
      dstfolder.CopyHere( aSrc, 0);
end;

procedure UnZip(aSrc, aDst: string);
var
  shell, srcFolder, dstFolder: Variant;
begin
    shell:= CreateOleObject( 'Shell.Application' );
    srcFolder:= shell.NameSpace( aSrc );
    dstfolder:= shell.NameSpace( aDst );
    dstfolder.CopyHere( srcFolder.Items, 0);
end;

procedure IBackup(aSrc, aDst: string);
var
  FSR, DSR: TFindRec;
  shell, srcFolder, dstFolder: Variant;
  sSrc, sDst, fileMask, zipstr: string;
  i: integer; FileList: array of TStringList;
  FindResult, IsPack, IsUnPack, SubDirsAllow: Boolean;
begin
  sSrc:= ExpandConstant(aSrc);
  sDst:= ExpandConstant(aDst);
  IsPack:= ExtractFileExt(sDst) = '.zip';
  IsUnPack:= (ExtractFileExt(sSrc) = '.zip') and not IsPack;
  if IsPack then   // DoZip
    begin
      if not FileExists(sDst) then
        begin
          if FileOrDirExists(sSrc) then
            begin
              zipstr:= Chr($50)+Chr($4B)+Chr($05)+Chr($06);
              for i:= 0 to 17 do
                zipstr:= zipstr + #0;
              ForceDirectories(ExtractFileDir(sDst));
              SaveStringToFile(sDst, zipstr, False);

              shell:= CreateOleObject( 'Shell.Application' );
              dstfolder:= shell.NameSpace( sDst );
              if DirExists(sSrc) then
                begin
                  srcFolder:= shell.NameSpace( sSrc );
                  dstfolder.CopyHere( srcFolder.Items, 0);
                end else
                  dstfolder.CopyHere( sSrc, 0);
              while FindWindowEx( 0, 0, '#32770', 'Compressing...'  ) = 0 do Sleep( 1 );
              while FindWindowEx( 0, 0, '#32770', 'Compressing...'  ) > 0 do Sleep( 200 );
            end else
              MsgBox('Invalid file name!', mbError, MB_OK);;
        end else
          MsgBox('Archive already exists!', mbError, MB_OK);
    end else  // End DoZip
  if IsUnpack then  // DoUnZip
    begin
      if FileExists(sSrc) then
        begin
          ForceDirectories(sDst);
          shell:= CreateOleObject( 'Shell.Application' );
          srcFolder:= shell.NameSpace( sSrc );
          dstfolder:= shell.NameSpace( sDst );
          dstfolder.CopyHere( srcFolder.Items, 0);
        end else
          MsgBox('Archive not found!', mbError, MB_OK);
    end else  // End DoUnZip
    begin  // DoCopy
      sDst:= AddBackslash(sDst)
      fileMask:= ExtractFileName(sSrc);
      if fileMask = '' then fileMask:= '*';
      SubDirsAllow:= fileMask = '*';
      sSrc := AddBackslash(ExtractFilePath(sSrc));
      SetArrayLength(FileList, 2);
      FileList[0]:= TStringList.Create();
      FileList[1]:= TStringList.Create();

      FindResult := FindFirst(sSrc + fileMask, FSR);
      try
        while FindResult do
        begin
          if FSR.Attributes and FILE_ATTRIBUTE_DIRECTORY = 0 then
{files}     begin
              FileList[0].Add(sSrc+FSR.Name);
              FileList[1].Add(sDst+FSR.Name);
            end;
          FindResult := FindNext(FSR);
        end;
        FindResult := FindFirst(sSrc + '*.*', DSR);
        while FindResult and SubDirsAllow do
        begin
          if ((DSR.Attributes and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY) and
            not ((DSR.Name = '.') or (DSR.Name = '..')) then
{Recursion}     IBackup(sSrc + AddBackslash(DSR.Name) + fileMask, sDst + DSR.Name);
          FindResult := FindNext(DSR);
        end;
      finally
        FindClose(FSR);
        FindClose(DSR);
      end;
      for i:= 0 to FileList[0].Count - 1 do
        begin
          ForceDirectories(ExtractFilePath(FileList[1].Strings[i]));
          FileCopy(FileList[0].Strings[i], FileList[1].Strings[i], False);
        end;
    end;  // End DoCopy
end;
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

procedure InitializeWizard();
begin
///////                       ////////

// 1.  ! TEMP   C:\Backup\
//      ,   
//   IBackup('C:\TEMP', 'C:\Backup\');

// 2.       TEMP  C:\Backup\
//      ,   
//   IBackup('C:\TEMP\', 'C:\Backup\');

// 3.       TEMP  C:\Backup\ (= .2)
//      ,   
//   IBackup('C:\TEMP\*', 'C:\Backup\');

// 4.    ( )   TEMP  C:\Backup\
//      ,   
//   IBackup('C:\TEMP\*.*', 'C:\Backup\');

// 5.    *.bmp   TEMP  C:\Backup\
//      ,   
//   IBackup('C:\TEMP\*.bmp', 'C:\Backup\');

// 6.    test.bmp   TEMP  C:\Backup\
//      ,   
//   IBackup('C:\TEMP\test.bmp', 'C:\Backup\');

// 7.    test.bmp   TEMP  C:\Backup\test.zip
//      ,   ;  test.zip   - 
//   IBackup('C:\TEMP\test.bmp', 'C:\Backup\test.zip');

// 8.    save.zip   TEMP  C:\Backup\test.zip
//      ,   ;  test.zip   - 
//   IBackup('C:\TEMP\save.zip', 'C:\Backup\test.zip');

// 9.     TEMP  C:\Backup\test.zip
//      ,   ;  test.zip   - 
//   IBackup('C:\TEMP\', 'C:\Backup\test.zip');

// 10.  C:\Backup\test.zip   TEMP
//      ,   ;  test.zip   - 
//   IBackup('C:\Backup\test.zip', 'C:\TEMP\');

// :
//  )   . :
//     IBackup('{app}\IMAGES\*.bmp', '{sd}\Backup\');
//  )    ,    !
//
///////////////////////////////////////////////////////////////
end;


