[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DirExistsWarning=no
DefaultDirName={pf}\My Program

[CustomMessages]
DEC_1   =Local system uses a modem to connect to the Internet.
DEC_2   =Local system uses a LAN to connect to the Internet.
DEC_4   =Local system uses a proxy server to connect to the Internet.
DEC_16  =Local system has RAS installed.
DEC_32  =Local system is in offline mode.
DEC_64  =Local system has a valid connection to the Internet,
DEC_64P =but it might or might not be currently connected.

[Code]
function InternetGetConnectedState(var lpdwFlags: DWORD; dwReserved: DWORD): boolean; external 'InternetGetConnectedState@wininet.dll stdcall';

const
  INTERNET_CONNECTION_MODEM = $01;
  INTERNET_CONNECTION_LAN = $02;
  INTERNET_CONNECTION_PROXY = $04;
  INTERNET_CONNECTION_MODEM_BUSY = $08;
  INTERNET_CONNECTION_OFFLINE = $20;
  INTERNET_CONNECTION_CONFIGURED = $40;

var
  TestSuccess: boolean;
  ConnectionState: DWORD;
  ConnectDescription: string;

procedure InitializeWizard();
begin
  TestSuccess:= InternetGetConnectedState(ConnectionState, 0);

  If TestSuccess then
    ConnectDescription:= 'You have connection to internet' + #13 +
      'and your connection has following parameters:'+ #13
  else
   ConnectDescription:= 'You havn''t connection to internet.'+ #13;

  If ConnectionState and INTERNET_CONNECTION_MODEM = INTERNET_CONNECTION_MODEM
    then ConnectDescription:= ConnectDescription + #13 + ExpandConstant('{cm:DEC_1}');

  If ConnectionState and INTERNET_CONNECTION_LAN = INTERNET_CONNECTION_LAN
    then ConnectDescription:= ConnectDescription + #13 + ExpandConstant('{cm:DEC_2}');

  If ConnectionState and INTERNET_CONNECTION_PROXY = INTERNET_CONNECTION_PROXY
     then ConnectDescription:= ConnectDescription + #13 + ExpandConstant('{cm:DEC_4}');

  If ConnectionState and INTERNET_CONNECTION_MODEM_BUSY = INTERNET_CONNECTION_MODEM_BUSY
     then ConnectDescription:= ConnectDescription + #13 + ExpandConstant('{cm:DEC_16}');

  If ConnectionState and INTERNET_CONNECTION_OFFLINE = INTERNET_CONNECTION_OFFLINE
     then ConnectDescription:= ConnectDescription + #13 + ExpandConstant('{cm:DEC_32}');

  If ConnectionState and INTERNET_CONNECTION_CONFIGURED = INTERNET_CONNECTION_CONFIGURED
     then ConnectDescription:= ConnectDescription + #13 + ExpandConstant('{cm:DEC_64}')
                                                  + #13 + ExpandConstant('{cm:DEC_64P}');
  MsgBox(ConnectDescription, mbInformation, MB_OK);
end;

