[Setup]
AppName=SlideShowOnBackground
AppVerName=SlideShowOnBackground
CreateAppDir=false

[Code]
function ReleaseCapture(): Longint;
 external 'ReleaseCapture@user32.dll stdcall';

const
  WM_SYSCOMMAND = $0112;

var
  CaptionPanel:Tpanel;
  MinimizeBtn,CloseBtn:TButton;

procedure MinimizeBtnClick(Sender:TObject);
begin
  SendMessage(WizardForm.Handle,WM_SYSCOMMAND,61472,0);
end;

procedure CloseBtnClick(Sender:TObject);
begin
  WizardForm.Close;
end;

procedure LabelOnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture
  SendMessage(WizardForm.Handle, WM_SYSCOMMAND, $F012, 0)
end;

procedure InitializeWizard;
var
  d:integer;
begin
  d:=WizardForm.Width-WizardForm.ClientWidth;
  with WizardForm do begin
    BorderStyle:=bsNone;
    Width:=Width+d;
    OuterNotebook.Left:=OuterNotebook.Left+d;
    Bevel.Visible:=False;
    Color:=$404040;
  end;
  CaptionPanel:=TPanel.Create(WizardForm);
  with CaptionPanel do begin
    Parent:=WizardForm;
    Height:=34;
    Width:=WizardForm.Width;
    Align:=alTop;
    ParentColor:=False;
    Color:=$800000;
    BevelInner:=bvNone;
    BevelOuter:=bvNone;
  end;
  with TLabel.Create(CaptionPanel) do begin
    Parent:=CaptionPanel;
    Top:=(CaptionPanel.Height-Height) div 2;
    Left:=d;
    Font.Color:=clWhite;
    Font.Style:=[fsBold];
    Caption:=WizardForm.Caption;
    OnMouseDown:=@LabelOnMouseDown;
  end;
  with TLabel.Create(CaptionPanel) do begin
    Parent:=CaptionPanel;
    Transparent:=True;
    Autosize:=False;
    Top:=0;
    Left:=0;
    Width:=CaptionPanel.Width;
    Height:=CaptionPanel.Height;
    OnMouseDown:=@LabelOnMouseDown;
  end;
  CloseBtn:=TButton.Create(CaptionPanel);
  with CloseBtn do begin
    Parent:=CaptionPanel;
    Height:=22;
    Width:=23;
    Top:=(CaptionPanel.Height-Height) div 2;
    Left:=CaptionPanel.Width-Width-d;
    Caption:='X';
    OnClick:=@CloseBtnClick;
  end;
  MinimizeBtn:=TButton.Create(CaptionPanel);
  with MinimizeBtn do begin
    Parent:=CaptionPanel;
    Height:=22;
    Width:=23;
    Top:=(CaptionPanel.Height-Height) div 2;
    Left:=CaptionPanel.Width-Width-CloseBtn.Width-d-2;
    Caption:='_';
    OnClick:=@MinimizeBtnClick;
  end;
  with WizardForm do begin
    OuterNotebook.Top:=OuterNotebook.Top+CaptionPanel.Height;
    CancelButton.Top:=CancelButton.Top+CaptionPanel.Height;
    NextButton.Top:=NextButton.Top+CaptionPanel.Height;
    BackButton.Top:=BackButton.Top+CaptionPanel.Height;
  end;
end;
