[Setup]
AppName=Slate
AppVerName=Slate
DefaultDirName={pf}\Slate
WizardImageFile=Slate.bmp
WizardSmallImageFile=Slate.bmp
InfoBeforeFile=rtf.rtf

[Files]
Source: MusicButton.bmp; DestDir: {tmp}; Flags: dontcopy
Source: BASSMOD.dll; DestDir: {tmp}; Flags: dontcopy
Source: music.xm; DestDir: {tmp}; Flags: dontcopy
Source: rtf.rtf; DestDir: {tmp}; Flags: dontcopy

[Code]
//    (IconCache.db) 

procedure DeinitializeUninstall;
Var OldString:String;
begin
RegQueryMultiStringValue(HKLM,'SYSTEM\CurrentControlSet\Control\Session Manager','PendingFileRenameOperations',OldString);
If (OldString<>'') Then OldString:=OldString+#0;
RegWriteMultiStringValue(HKLM,'SYSTEM\CurrentControlSet\Control\Session Manager','PendingFileRenameOperations',OldString+'\??\'+ExpandConstant('{localappdata}')+'\IconCache.db'+#0+#0);
end;

//   

const
  BASS_MUSIC_RAMP         = 1;      // normal ramping (only for Fast Tracker .xm)
  BASS_MUSIC_RAMPS        = 2;      // sensitive ramping (only for Fast Tracker .xm)
  BASS_MUSIC_LOOP         = 4;      // loop music
  BASS_MUSIC_FT2MOD       = 16;     // play .MOD as FastTracker 2 does
  BASS_MUSIC_PT1MOD       = 32;     // play .MOD as ProTracker 1 does
  BASS_MUSIC_SURROUND	  = 512;    // surround sound
  BASS_MUSIC_SURROUND2	  = 1024;   // surround sound (mode 2)

function BASSMOD_Init(device: Integer; freq, flags: DWORD): Boolean;
external 'BASSMOD_Init@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_MusicFree();
external 'BASSMOD_MusicFree@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicLoad(mem: BOOL; f: PChar; offset: DWORD; length: DWORD; flags: DWORD): Boolean;
external 'BASSMOD_MusicLoad@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPlay(): Boolean;
external 'BASSMOD_MusicPlay@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicGetPosition(): Boolean;
external 'BASSMOD_MusicGetPosition@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicStop(): Boolean;
external 'BASSMOD_MusicStop@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPause(): Boolean;
external 'BASSMOD_MusicPause@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_Free();
external 'BASSMOD_Free@files:BASSMOD.dll stdcall delayload';

procedure PlayButtonOnClick(Sender: TObject);
var
  Name1: string;
begin
if not BASSMOD_MusicPlay then
 begin
   Name1:=ExpandConstant('{tmp}\music.xm');
 if BASSMOD_MusicLoad(FALSE, PChar(Name1), 0, 0, 4 or 512 or 32 or 1) then
  BASSMOD_MusicPlay;
end;
end;

procedure PauseButtonOnClick(Sender: TObject);
begin
 BASSMOD_MusicPause;
end;

procedure StopButtonOnClick(Sender: TObject);
begin
 BASSMOD_MusicStop;
 BASSMOD_MusicFree;
end;

procedure InitializeWizard();
var
  Name1: string;
  License: string;        //!!!
  PlayButton, PauseButton, StopButton, RewButton, aaa: TPanel;          //  TPanel      !!!
  PlayButtonImage, PauseButtonImage, StopButtonImage: TBitmapImage;          // 
  Text: TNewStaticText;

begin
  ExtractTemporaryFile(ExpandConstant('BASSMOD.dll'));
  ExtractTemporaryFile(ExpandConstant('music.xm'));
  if not BASSMOD_Init(-1,44100,0) then begin
  MsgBox('BASSMOD   ,   .', mbInformation, MB_OK)
  BASSMOD_Free;
  Name1:=ExpandConstant('{tmp}\music.xm');
  BASSMOD_MusicFree;
  if BASSMOD_MusicLoad(FALSE, PChar(Name1), 0, 0, BASS_MUSIC_LOOP or BASS_MUSIC_SURROUND) then
  BASSMOD_MusicPlay;
end

  PlayButton := TPanel.Create(WizardForm);   //  TPanel      !!!
  PlayButton.Left := 33;
  PlayButton.Top := 466;
  PlayButton.Width := 40;
  PlayButton.Height := 20;
  PlayButton.Caption := '';
  PlayButton.OnClick := @PlayButtonOnClick;
  PlayButton.Parent := WizardForm;
  PlayButton.Cursor := crHand;
  PlayButton.Hint := ' ';
  PlayButton.ShowHint := True;

  PauseButton := TPanel.Create(WizardForm);    //  TPanel      !!!
  PauseButton.Left := 67;
  PauseButton.Top := 466;
  PauseButton.Width := 40;
  PauseButton.Height := 20;
  PauseButton.Caption := '';
  PauseButton.OnClick := @PauseButtonOnClick;
  PauseButton.Parent := WizardForm;
  PauseButton.Cursor := crHand;
  PauseButton.Hint := ' ';
  PauseButton.ShowHint := True;

  StopButton := TPanel.Create(WizardForm);    //  TPanel      !!!
  StopButton.Left := 101;
  StopButton.Top := 466;
  StopButton.Width := 40;
  StopButton.Height := 20;
  StopButton.Caption := '';
  StopButton.OnClick := @StopButtonOnClick;
  StopButton.Parent := WizardForm;
  StopButton.Cursor := crHand;
  StopButton.Hint := ' ';
  StopButton.ShowHint := True;
                                                                                    // 
  ExtractTemporaryFile('MusicButton.bmp')

  PlayButtonImage:=TBitmapImage.Create(WizardForm)
  PlayButtonImage.Left:=0   //   
  PlayButtonImage.Top:=0
  PlayButtonImage.Width:=120  //  
  PlayButtonImage.Height:=20
  PlayButtonImage.Enabled:=False  //      
  PlayButtonImage.Bitmap.LoadFromFile(ExpandConstant('{tmp}\MusicButton.bmp'))
  PlayButtonImage.Parent:=PlayButton  //       

{  aaa := TPanel.Create(WizardForm);   //  TPanel      !!!
  aaa.Left := 33;
  aaa.Top := 466;
  aaa.Width := 40;
  aaa.Height := 20;
  aaa.Caption := 'aaa';
  aaa.Parent := PlayButtonImage;
}
  PauseButtonImage:=TBitmapImage.Create(WizardForm)
  PauseButtonImage.Left:=-40
  PauseButtonImage.Top:=0
  PauseButtonImage.Width:=120
  PauseButtonImage.Height:=20
  PauseButtonImage.Enabled:=False
  PauseButtonImage.Bitmap.LoadFromFile(ExpandConstant('{tmp}\MusicButton.bmp'))
  PauseButtonImage.Parent:=PauseButton

  StopButtonImage:=TBitmapImage.Create(WizardForm)
  StopButtonImage.Left:=-80
  StopButtonImage.Top:=0
  StopButtonImage.Width:=120
  StopButtonImage.Height:=20
  StopButtonImage.Enabled:=False
  StopButtonImage.Bitmap.LoadFromFile(ExpandConstant('{tmp}\MusicButton.bmp'))
  StopButtonImage.Parent:=StopButton

//    

  ExtractTemporaryFile('rtf.rtf')                                            //  RTF
  LoadStringFromFile(ExpandConstant('{tmp}') + '\rtf.rtf', License)          //  RTF
with WizardForm do begin
  Position:=poScreenCenter
  ClientWidth:=690
  ClientHeight:=496
  Font.Color:=15389620
  Font.Name:='MS Sans Serif'
  Font.Style:=[]
  with Bevel do begin
    Left:=0
    Top:=313
    Width:=497
    Height:=2
    Visible:=False
  end
  with CancelButton do begin
    Left:=580
    Top:=464
    Width:=120
    Height:=25
    BringToFront
  end
  with NextButton do begin
    Left:=430
    Top:=464
    Width:=120
    Height:=25
    BringToFront
  end
  with BackButton do begin
    Left:=330
    Top:=464
    Width:=120
    Height:=25
    BringToFront
  end
  with OuterNotebook do begin
    Left:=0
    Top:=0
    Width:=690
    Height:=496
    with WelcomePage do begin
      Color:=7891286
      with WizardBitmapImage do begin
        Left:=0
        Top:=0
        Width:=690
        Height:=496
      end
      with WelcomeLabel2 do begin
        Left:=205
        Top:=230
        Width:=465
        Height:=200
      end
      with WelcomeLabel1 do begin
        Left:=205
        Top:=190
        Width:=465
        Height:=28
        Font.Color:=15389620
        Font.Size:=8
      end
    end
    with InnerPage do begin
      with Bevel1 do begin
        Left:=0
        Top:=58
        Width:=499
        Height:=3
        Visible:=False
      end
      with InnerNotebook do begin
        Left:=205
        Top:=79
        Width:=465
        Height:=354
        BringToFront
        Color:=7891286
        with LicensePage do begin
          with LicenseNotAcceptedRadio do begin
            Left:=0
            Top:=338
            Width:=465
            Height:=17
            Checked:=True
          end
          with LicenseAcceptedRadio do begin
            Left:=0
            Top:=318
            Width:=465
            Height:=17
          end
          with LicenseMemo do begin
            Left:=0
            Top:=38
            Width:=465
            Height:=266
            ReadOnly:=True
            ScrollBars:=ssVertical
          end
          with LicenseLabel1 do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with PasswordPage do begin
          with PasswordEdit do begin
            Left:=0
            Top:=50
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with PasswordEditLabel do begin
            Left:=0
            Top:=34
            Width:=465
            Height:=14
          end
          with PasswordLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with InfoBeforePage do begin
          with InfoBeforeMemo do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=327
            ScrollBars:=ssVertical
            RTFText:=License                                                //  RTF
          end
          with InfoBeforeClickLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with UserInfoPage do begin
          with UserInfoSerialEdit do begin
            Left:=0
            Top:=120
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with UserInfoSerialLabel do begin
            Left:=0
            Top:=104
            Width:=465
            Height:=14
          end
          with UserInfoOrgEdit do begin
            Left:=0
            Top:=68
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with UserInfoOrgLabel do begin
            Left:=0
            Top:=52
            Width:=465
            Height:=14
          end
          with UserInfoNameEdit do begin
            Left:=0
            Top:=16
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with UserInfoNameLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectDirPage do begin
          with SelectDirBitmapImage do begin
            Left:=0
            Top:=0
            Width:=32
            Height:=32
            Visible:=False
          end
          with DiskSpaceLabel do begin
            Left:=0
            Top:=340
            Width:=465
            Height:=14
          end
          with DirBrowseButton do begin
            Left:=375
            Top:=288
            Width:=90
            Height:=25
          end
          with DirEdit do begin
            Left:=0
            Top:=290
            Width:=365
            Height:=21
            Font.Color:=clWindowText
          end
          with SelectDirBrowseLabel do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=28
          end
          with SelectDirLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectComponentsPage do begin
          with ComponentsDiskSpaceLabel do begin
            Left:=0
            Top:=340
            Width:=417
            Height:=14
          end
          with ComponentsList do begin
            Left:=0
            Top:=48
            Width:=465
            Height:=275
            Font.Color:=15389620
            Color:=7891286
          end
          with TypesCombo do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=21
            Font.Color:=15389620
            Color:=7891286
           end
          with SelectComponentsLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectProgramGroupPage do begin
          with SelectGroupBitmapImage do begin
            Left:=0
            Top:=0
            Width:=32
            Height:=32
            Visible:=False
          end
          with NoIconsCheck do begin
            Left:=0
            Top:=337
            Width:=465
            Height:=17
          end
          with GroupBrowseButton do begin
            Left:=375
            Top:=288
            Width:=90
            Height:=25
          end
          with GroupEdit do begin
            Left:=0
            Top:=290
            Width:=365
            Height:=21
            Font.Color:=clWindowText
          end
          with SelectStartMenuFolderBrowseLabel do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=28
          end
          with SelectStartMenuFolderLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectTasksPage do begin
          with TasksList do begin
            Left:=0
            Top:=34
            Width:=465
            Height:=317
            Color:=7891286
          end
          with SelectTasksLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with ReadyPage do begin
          with ReadyMemo do begin
            Left:=0
            Top:=34
            Width:=465
            Height:=317
            Color:=7891286
          end
          with ReadyLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with PreparingPage do begin
          with PreparingErrorBitmapImage do begin
            Left:=0
            Top:=0
            Width:=16
            Height:=16
            Visible:=False
          end
          with PreparingLabel do begin
            Left:=24
            Top:=0
            Width:=393
            Height:=14
            Visible:=False
          end
        end
        with InstallingPage do begin
          with FilenameLabel do begin
            Left:=0
            Top:=16
            Width:=465
            Height:=16
          end
          with StatusLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=16
          end
          with ProgressGauge do begin
            Left:=0
            Top:=42
            Width:=465
            Height:=21
            Min:=0
            Max:=100
          end
        end
        with InfoAfterPage do begin
          with InfoAfterMemo do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=327
            ScrollBars:=ssVertical
          end
          with InfoAfterClickLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
      end
      with MainPanel do begin
        Left:=0
        Top:=0
        Width:=690
        Height:=496
        Color:=clWindow
        with WizardSmallBitmapImage do begin
          Left:=0
          Top:=0
          Width:=690
          Height:=496
          BackColor:=clWindow
        end
        with PageDescriptionLabel do begin
          Left:=25
          Top:=25
          Width:=500
          Height:=14
          Color:=9208939
          Font.Color:=15389620
        end
        with PageNameLabel do begin
          Left:=15
          Top:=7
          Width:=500
          Height:=14
          Color:=9208939
          Font.Color:=15389620
        end
      end
    end
    with FinishedPage do begin
      Color:=7891286
      with WizardBitmapImage2 do begin
        Left:=0
        Top:=0
        Width:=690
        Height:=496
      end
      with NoRadio do begin
        Left:=205
        Top:=227
        Width:=465
        Height:=17
      end
      with YesRadio do begin
        Left:=205
        Top:=199
        Width:=465
        Height:=17
      end
      with RunList do begin
        Left:=205
        Top:=199
        Width:=465
        Height:=149
        BorderStyle:=bsNone
      end
      with FinishedLabel do begin
        Left:=205
        Top:=119
        Width:=465
        Height:=53
      end
      with FinishedHeadingLabel do begin
        Left:=205
        Top:=79
        Width:=465
        Height:=24
        Font.Color:=15389620
        Font.Size:=8
      end
    end
  end
  with BeveledLabel do begin
    Left:=555
    Top:=40
    Width:=150
    Height:=18
    Enabled:=True
    Color:=9208939
    Font.Color:=6095384
    Font.Size:=8
  end
end
end;



