[Setup]
AppName=Need for Speed - Carbon
AppVerName=Need for Speed - Carbon v1.3
DefaultDirName={sd}\Games\NFSCarbon
DefaultGroupName=NFSCarbon
OutputDir=D:\NFS
OutputBaseFilename=setup
Compression=lzma/ultra
SolidCompression=no
DiskSpanning=yes
DiskSliceSize=727000000
AllowNoIcons=yes
UninstallLogMode=overwrite

[Languages]
Name: "russian"; MessagesFile: "compiler:Languages\Russian.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked

[Components]
Name: "eng"; Description: " ";  Flags: exclusive
Name: "rus"; Description: " ";  Flags: exclusive

[Types]
Name: "custom"; Description: " "; Flags: iscustom

[Files]
Source: "D:\NFSCarbon\*"; DestDir: "{app}"; Flags: ignoreversion recursesubdirs createallsubdirs

[Icons]
Name: "{group}\  NFS - Carbon"; Filename: "{app}\nfsc.exe"; WorkingDir: "{app}"
Name: "{group}\ NFS - Carbon"; Filename: "{uninstallexe}"; WorkingDir: "{app}"
Name: "{userdesktop}\NFS - Carbon"; Filename: "{app}\nfsc.exe"; Tasks: desktopicon; WorkingDir: "{app}"

[Registry]
Root: HKLM; Subkey: "Software\NFSCarbon"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\NFSCarbon"; ValueType: string; ValueName: "InstallPath"; ValueData: "{app}"

Root: HKLM; SubKey: SOFTWARE\Electronic Arts; Flags: uninsdeletekeyifempty
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Electronic Arts; Flags: uninsdeletekeyifempty
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Electronic Arts\Need for Speed Carbon; Flags: uninsdeletekey

Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; Flags: uninsdeletekey

Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon\1.0; ValueType: string; ValueName: LanguageName; ValueData: English US
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon\1.0; ValueType: string; ValueName: DisplayName; ValueData: Need for Speed Carbon
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon\1.0; ValueType: dword; ValueName: Language; ValueData: $00000001
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Suppression Exe; ValueData:
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Patch URL; ValueData: "http://patches.ea.com/nfs_carbon/home.html "
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Folder; ValueData: {app}
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Region; ValueData: NA
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Product GUID; ValueData: {{259C0ABB-A3B2-4D70-008F-BF7EE491B70B}
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Install Dir; ValueData: {app}
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: CD Drive; ValueData: {src}
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Locale; ValueData: en_us
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Language; ValueData: English US
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: SwapSize; ValueData: 73400320
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: CacheSize; ValueData: 5697825792
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Registration; ValueData: SOFTWARE\Electronic Arts\Electronic Arts\Need for Speed Carbon\ergc
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: Installed From; ValueData: {srcexe}
Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Need for Speed Carbon; ValueType: string; ValueName: DisplayName; ValueData: Need for Speed Carbon

Root: HKLM; SubKey: SOFTWARE\Electronic Arts\Electronic Arts\Need for Speed Carbon\ergc; ValueType: string; ValueName: ; ValueData: YEPPPFARO8L7L8M21911

Root: HKLM; Subkey: "SOFTWARE\Electronic Arts\Need for Speed Carbon"; ValueName: "Language"; ValueType: String; ValueData: "German"; Components: rus;
Root: HKLM; Subkey: "SOFTWARE\Electronic Arts\Need for Speed Carbon"; ValueName: "Locale"; ValueType: String; ValueData: "en"; Components: rus;
Root: HKLM; Subkey: "SOFTWARE\Electronic Arts\Need for Speed Carbon\1.0"; ValueName: "Language"; ValueType: Dword; ValueData: "$E"; Components: rus;
Root: HKLM; Subkey: "SOFTWARE\Electronic Arts\Need for Speed Carbon\1.0"; ValueName: "LanguageName"; ValueType: String; ValueData: "German"; Components: rus;

[Run]
Components: rus; Filename: "{src}\Rus\NFSC_RUS.exe"; WorkingDir: "{src}\Rus"; Parameters: "-y -o""{app}"""; StatusMsg: " ..."; Flags: waituntilterminated
Components: rus; Filename: "{app}\update.exe"; WorkingDir: "{app}"; StatusMsg: " GlobalMemoryFile.bin..."; Flags: waituntilterminated
Components: rus; Filename: "{app}\install.bat"; WorkingDir: "{app}"; StatusMsg: " MOVIES\*.vp6..."; Flags: waituntilterminated

[UninstallDelete]
Type: filesandordirs; Name: "{app}\MOVIES"
